;
; LOD Player Version 2
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

store_cnt	= $DA
store		= store_cnt - 4*5

freqs = $0500

PLAYER_FREQ_INIT
	jmp _PLAYER_FREQ_INIT
PLAYER
	jmp _PLAYER
PLAYER_SOUND
	jmp _PLAYER_SOUND

freqs_add
	db 07,57,54,51, 48,45,43,40, 38,36,34,32 ; 00
	db 31,28,27,25, 24,23,21,21, 19,18,17,16 ; 12
	db 15,14,14,12, 12,12,10,10, 10,09,08,08 ; 24
	db 08,07,07,06, 06,06,05,05, 05,04,05,04 ; 36
	db 03,04,03,04, 03,02,03,03, 02,02,02,02 ; 48
	db 02,02,02,02+24			 ; 60 (63=off)
	
; COMMAND BYTES

END_MARK	= $FF
RETRIG		= $FE
SET_VOLTAB	= $FD
SET_SLIDE	= $FC
SET_ARP		= $FB
SETINS		= $F0
SETVOL		= $E0
SETLEN		= $40

; Constants
base_note = 0 ; shift to C0
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

OFF = 63

;-----

_PLAYER_FREQ_INIT
	;         
	; *** Freq init
	;              
;	LDA #$00
;	CLC
;	ADC freqs_add
;	STA freqs
;	LDA #$00
;	ADC #$00
;	STA freqs+1
	;
	ldx #$FF
	stx VOLTAB_CNT
	inx
	stx NOTE1
	stx NOTE2
	stx VOLUME
	inx
	stx NOTELEN1
	stx NOTELEN2
	inx		; x=2
	;
	lda freqs_add
	sta freqs
	ldy #$00 
	sty freqs+1
	;
freq_init
	lda freqs-2,x
	clc
	adc freqs_add+1,y
	sta freqs,x
	inx
	lda freqs-2,x
	adc #$00
	sta freqs,x
	iny
	inx
	bpl freq_init
	;
PLAYER_INIT
	ldx #Channel1 & 255 ;SPCH1
	ldy #Channel1 >> 8 ;SPCH1 + 1
	stx PCH1
	sty PCH1 + 1
	;
	ldx #Channel2 & 255 ;SPCH2
	ldy #Channel2 >> 8 ; SPCH2 + 1
	stx PCH2
	sty PCH2 + 1
	;
	jsr advance_ch1
	jsr advance_ch2
	;
	lda #vol_default & 255		; no need to set, music data sets it
	sta VOL_TAB
	lda #vol_default >> 8
	sta VOL_TAB+1
	;
	rts

res_1	jsr reset_ch1
	;
advance_ch1
	ldy #$01
	lda (PCH1),y	; HI byte
	beq res_1
	sta CH1 + 1
	dey
	lda (PCH1),y	; LO byte
	sta CH1
	inc PCH1
	inc PCH1
	rts
	
;set_ch1
;	STX SPCH1
;	STY SPCH1 + 1
;	RTS

reset_ch1
	ldx #Channel1_restart & 255 ;SPCH1
	ldy #Channel1_restart >> 8 ;SPCH1 + 1
	stx PCH1
	sty PCH1 + 1
	rts
	
reset_ch2
	ldx #Channel2_restart & 255 ;SPCH2
	ldy #Channel2_restart >> 8 ; SPCH2 + 1
	stx PCH2
	sty PCH2 + 1
	rts
	
res_2	jsr reset_ch2
	;
advance_ch2
	ldy #$01
	lda (PCH2),y
	beq res_2
	;
	sta CH2 + 1
	;
	dey
	lda (PCH2),y
	sta CH2
	;
	inc PCH2
	inc PCH2
	;
	rts

;set_ch2
;	STX SPCH2
;	STY SPCH2 + 1
;	RTS

	;
	;##################
	;

_PLAYER
	;------------------
	inc NOTE1
	;INC ARP_CNT1
	;
	;JMP *
	;
	lda NOTE1
	cmp NOTELEN1
	beq next_note1
	jmp channel2
	;
new_pattern1
	jsr advance_ch1
	;
next_note1
	ldy #$00
	sty NOTE1		; reset note counter
	sty TICK1
	sty ARP_CNT1		; reset arp counter
	;
	lda (CH1),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	beq new_pattern1
	;
	cmp #SET_VOLTAB
	bne pl_11
	;
	lda #$FF		; reset voltab counter
	sta VOLTAB_CNT
	;STA VOLUME		; disable SET volume
	;
	lda (CH1),y		; get lo byte
	sta VOL_TAB
	iny
	;
	;LDA (CH1),y		; get hi byte
	;STA VOL_TAB+1
	;INY
	;
	lda (CH1),y		; get byte
	iny
	;
pl_11	
;	CMP #$FC
;	BNE pl_12
;	;
;	LDA (CH1),y		; get SLIDE lo byte
;	STA slide
;	INY
;	;
;	LDA (CH1),y		; get SLIDE hi byte
;	STA slide+1
;	INY
;	;
;	LDA (CH1),y		; get byte
;	INY
;	;
;pl_12	
	cmp #SET_ARP
	bne pl_14
	;
	lda (CH1),y		; get arp lo byte
	sta arp_ptr1+1
	iny
	;
	;LDA (CH1),y		; get arp hi byte
	;STA arp_ptr1+2
	;INY
	;
	lda (CH1),y		; get byte
	iny
	;
pl_14	cmp #$F0		; instrument change?
	bcc pl_01
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE1   	; store instrument type
	;
	lda (CH1),y		; get byte
	iny
	;
pl_01	
;	CMP #$E0
;	BCC pl_05
;	;
;	AND #$0F
;	STA VOLUME		; store direct volume set value
;	;
;	LDA (CH1),y		; get byte
;	INY
;	;
pl_05	
	cmp #$40		; set note length?
	bcc pl_02
	;
	sec
	sbc #$40
	sta NOTELEN1
	;
	lda (CH1),y
	iny
	;
pl_02	; - store note!
	;
	ldx TONE1		; keep previous
	cpx #OFF
	beq no_prev1
	stx TONE_PREV1
no_prev1
	sta TONE1
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH1
	sta CH1
	bcc noi_1
	inc CH1 + 1
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel2
	inc NOTE2
	;INC ARP_CNT2
	;
	lda NOTE2
	cmp NOTELEN2
	beq next_note2
	bne pl_50
	;  
new_pattern2
	;JMP *
	jsr advance_ch2
	;
next_note2
	ldy #$00
	sty NOTE2		; reset note counter
	sty TICK2
	sty ARP_CNT2		; reset arp counter
	;
	lda (CH2),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	beq new_pattern2
	;
	cmp #SET_ARP
	bne pl_24
	;
	lda (CH2),y		; get arp lo byte
	sta arp_ptr2+1
	iny
	;
	;LDA (CH2),y		; get arp hi byte
	;STA arp_ptr2+2
	;INY
	;
	lda (CH2),y		; get byte
	iny
	;
pl_24	cmp #$F0		; instrument change?
	bcc pl_21
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE2   	; store instrument type
	;
	lda (CH2),y		; get byte
	iny
	;
pl_21	
;	CMP #$E0
;	BCC pl_25
;	;
;	AND #$0F
;	STA VOLUME
;	;
;	LDA (CH2),y		; get byte
;	INY
;	;
pl_25	
	cmp #$40		; set note length?
	bcc pl_22
	;
	sec
	sbc #$40
	sta NOTELEN2
	;
	lda (CH2),y
	iny
	;
pl_22	; - store note!
	;
	ldx TONE2		; keep previous
	cpx #OFF
	beq no_prev2
	stx TONE_PREV2
no_prev2
	sta TONE2
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH2
	sta CH2
	bcc noi_2
	inc CH2 + 1
noi_2	;     
	;
	;    
pl_50	ldy VOLTAB_CNT
	iny
	lda (VOL_TAB),y
	bpl noi_3		; check for $FF
	ldy #$00		; reached, so warp
noi_3	sty VOLTAB_CNT
	;              
	;			; --- special: reset store counter
	lda #$00
	sta store_cnt		
	;
	; --- SOUND PROCESSING
	;
_PLAYER_SOUND
	lda #$20		; assume no noise
	sta NOISE
	;
	inc ARP_CNT1
	inc ARP_CNT2
	;
	ldx #$00		; channel 0
	jsr sound
	;
	ldx store_cnt
	sta store,x
	sty store+4,x
;	STA F1LO
;	STY F1HI_x+1
;	;
;	LDA F1HI
;	AND #$FC
;F1HI_x	ORA #$00
;	STA F1HI
	;
	ldx #$01		; channel 1
	jsr sound
	;
	ldx store_cnt
	sta store+1,x
	sty store+2,x
	;STA F2LO
	;STY F2HI
	;
	txa
	clc
	adc #$05
	sta store_cnt
	;
	; ---
	;    
	inc TICK1
	inc TICK2
	;
	; ---
	;  
	ldy VOLTAB_CNT
	lda (VOL_TAB),y		; nope, read from envelope
	clc
	adc VOLUME
	tay
	lda volume_map,y
	ora NOISE
setvol	bit $FF11	    
	sta store   +3
	sta store+5 +3
	sta store+10+3
	sta store+15+3
	;     
	rts     
	;
inst_table
	dw normal, bassdrum, snare, add_hihat, arp, glide ;, vib
	;
sound	
	;LDA TONE1,x		; OFF means no further processing
	;CMP #OFF
	;BEQ normal
	; 
	;JMP *
	lda INS_TYPE1,x
	asl a
	tay
	lda inst_table,y
	sta inst_jump+1
	lda inst_table+1,y
	sta inst_jump+2
	;
inst_jump
	jmp $0000
	;
	; ---
	;
add_hihat
	lda TICK1,x
	cmp #$02
	bcs normal
	asl a
	tax
	;
	lda #$40		; turn on noise bit
	sta NOISE
	;
	lda hihat_freq,x
	ldy hihat_freq+1,x
	rts
	
arp_restart
	and #$0F		; low byte is new position
	sta ARP_CNT1,x
	;JMP arp			; again!
arp	
	;LDA TONE1,x		; extra feature: OFF "knows" not to use arp
	;CMP #OFF
	;BEQ lookup
	;
	ldy ARP_CNT1,x		; load current arp counter
	;
	cpx #$00		; check which channel
	beq arp_ptr1
arp_ptr2
	lda arpeggio,y		; for channel 2 (self-mod)
	jmp arp_1
arp_ptr1
	lda arpeggio,y		; for channel 1 (self-mod)
arp_1
	bmi arp_restart		; check for negative numbers
	;
arp_add
	clc
	adc TONE1,x
	db $2C			; skip next 2 bytes
	;
	; ---
	;
normal	lda TONE1,x		; normal note
lookup	asl a
	tax
	lda freqs,x
	ldy freqs+1,x
	rts
	
;	;
;slider	;
;;	LDA slide
;;	BNE sl_01
;;	DEC slide+1
;;sl_01	DEC slide
;	;  
;	LDA TICK1,x
;	BNE add1
;	;
;	LDA slide
;	LDY slide+1
;	RTS
;	;
;add1	LDA TONE1,x
;	ASL a
;	TAX
;	LDY freqs+1,x
;	LDA freqs,x
;	CLC
;	ADC #$01
;	BCC sl_03
;	INY
;sl_03	RTS
	;                                 
	;TAX
	;LDA bass_freq,x
	;LDY bass_freq+1,x
	;RTS              
	
;vibX	LDA NOTE1,x
;	AND #$0F
;	TAY
;	LDA vibrato2,y
;	BMI vib_sub1
;	BPL vib_add

;vib	LDA TICK1,x
;	AND #$0F
;	TAY
;	LDA vibrato,y
;	BMI vib_sub1
;	;
;vib_add
;	STA vib2+1
;	;
;	LDA TONE1,x
;	ASL a
;	TAX
;	LDY freqs+1,x
;	LDA freqs,x
;	CLC
;vib2	ADC #$01
;	BCC vib3
;	INY
;vib3	RTS
;	;
;vib_sub1
;	AND #$7F
;	;      
;	STA vib4+1
;	;
;	LDA TONE1,x
;	ASL a
;	TAX
;	LDY freqs+1,x
;	LDA freqs,x
;	SEC
;vib4	SBC #$01
;	BCS vib5
;	DEY
;vib5	RTS

;glide_2	JMP normal

glide	lda TICK1,x
	beq glide_1
	;
	;
	;
	cmp #$04			; change this to determine glide length
	bcs normal
	;
	lda glide_add
	bmi glide_sub
	;
	lda glide_freq_current
	clc
	adc glide_freq_diff
	sta glide_freq_current
	lda glide_freq_current+1
	adc glide_freq_diff+1
	sta glide_freq_current+1
	lda glide_freq_current+2
	adc glide_freq_diff+2
	sta glide_freq_current+2
	;
	lda glide_freq_current+1
	ldy glide_freq_current+2
	;
	rts
	;
glide_sub
	lda glide_freq_current
	sec
	sbc glide_freq_diff
	sta glide_freq_current
	lda glide_freq_current+1
	sbc glide_freq_diff+1
	sta glide_freq_current+1
	lda glide_freq_current+2
	sbc glide_freq_diff+2
	sta glide_freq_current+2
	;
	lda glide_freq_current+1
	ldy glide_freq_current+2
	;
	rts
	;
	; first iteration
	;
glide_1	lda TONE1,x			; look up destination freq
	asl a
	tay
	lda freqs,y
	sta glide_freq_dest+1
	lda freqs+1,y   
	sta glide_freq_dest+2
	;
	lda TONE_PREV1,x		; look up previous freq
	asl a
	tay
	lda freqs,y
	sta glide_freq_current+1
	lda freqs+1,y   
	sta glide_freq_current+2
	;
	lda #$00             		; clear low bytes of 24 bit values
	sta glide_freq_dest
	sta glide_freq_current
	sta glide_freq_diff
	;
	lda TONE1,x
	cmp TONE_PREV1,x
	bcc glide_down
	;
	; up
	;
	lda glide_freq_dest+1		; diff = dest - current
	sec
	sbc glide_freq_current+1
	sta glide_freq_diff+1
	lda glide_freq_dest+2
	sbc glide_freq_current+2
	sta glide_freq_diff+2
	;
	lda #$00
gl_up	sta glide_add
	;
	lsr glide_freq_diff+2		; 24 bit div routine
	ror glide_freq_diff+1
	ror glide_freq_diff		; div2
	lsr glide_freq_diff+2
	ror glide_freq_diff+1
	ror glide_freq_diff		; div4
	lsr glide_freq_diff+2
	ror glide_freq_diff+1
	ror glide_freq_diff		; div8
	;LSR glide_freq_diff+2
	;ROR glide_freq_diff+1
	;ROR glide_freq_diff
	;
	lda glide_freq_current+1
	ldy glide_freq_current+2
	;
	rts

glide_down
	lda glide_freq_current+1	; diff = current - dest
	sec
	sbc glide_freq_dest+1
	sta glide_freq_diff+1
	lda glide_freq_current+2
	sbc glide_freq_dest+2
	sta glide_freq_diff+2
	;
	lda #$80     
	bne gl_up			; always jump
	
;snare2	LDA TONE1,x		; look up note freq
;	ASL a
;	TAY
;	;
;	LDA TICK1,x
;	CLC
;	ADC #snare2_freq-snare_freq
;	JMP drum_lookup

snare	lda TONE1,x		; look up note freq
	asl a
	tay
	;
	lda TICK1,x
drum_lookup
	tax  
	;
	lda snare_freq,x	; add snare freq
	clc
	adc freqs,y       	; add 8 bit value
	pha
	lda freqs+1,y
	adc #$00
	tay
	;   
	lda #$40		; turn on noise bit
	sta NOISE
	;
	pla
	rts
	
bassdrum
	lda TICK1,x
	asl a
	tax
	lda bass_freq,x
	ldy bass_freq+1,x
	rts
	
;	LDA TONE1,x		; look up note freq
;	ASL a
;	TAY
;	;
;	LDA TICK1,x
;	ASL a
;	ADC #bass_freq-snare_freq
;	TAX  
;	;
;	LDA snare_freq,x	; 16 bit add: add bass-drum freq
;	CLC
;	ADC freqs,y       
;	PHA
;	LDA snare_freq+1,x
;	ADC freqs+1,y
;	TAY
;	PLA
	rts

;vibrato
;	db $00,$03,$05,$06
;	db $07,$06,$05,$03 
;	db $00,$83,$85,$86
;	db $87,$86,$85,$83
	
snare_freq
	db $F0,$90,$E8,$80
	db $E0,$70,$D0,$60
	db $C8,$50,$C0,$40
	db $C0,$20,$C0,$00
	
hihat_freq
	dw $03E4
	dw $03E2
	dw $03D0
	dw $03C0

bass_freq
	dw 600,500,400,300
	dw 275,250,225,200
	dw 175,150,125,100
	dw 075,035,015,007
	